package Models

import "github.com/gofrs/uuid"

type MessageData struct {
	Base
	Data []byte `gorm:"not null" json:"data"` // Stored encrypted
}

type MessageKey struct {
	Base
	UserID        uuid.UUID `gorm:"type:uuid;column:user_id;not null;" json:"user_id"`
	MessageDataID uuid.UUID `gorm:"type:uuid;column:message_data_id;not null;" json:"message_data_id"`
	SymmetricKey  []byte    `gorm:"not null" json:"symmetric_key"` // Stored encrypted
}
