import 'package:flutter/material.dart';
import 'package:font_awesome_flutter/font_awesome_flutter.dart';
import './login.dart';
import './signup.dart';

class UnauthenticatedLandingWidget extends StatefulWidget {
    const UnauthenticatedLandingWidget({Key? key}) : super(key: key);

    @override
    State<UnauthenticatedLandingWidget> createState() => _UnauthenticatedLandingWidgetState();
}


class _UnauthenticatedLandingWidgetState extends State<UnauthenticatedLandingWidget> {
    @override
    Widget build(BuildContext context) {
        final ButtonStyle buttonStyle = ElevatedButton.styleFrom(
                primary: Colors.white,
                onPrimary: Colors.cyan,
                minimumSize: const Size.fromHeight(50),
                padding: const EdgeInsets.symmetric(horizontal: 10, vertical: 10),
                textStyle: const TextStyle(
                        fontSize: 20, 
                        fontWeight: FontWeight.bold,
                        color: Colors.red,
                ),
        );

        return WillPopScope(
                onWillPop: () async => false,
                child: Scaffold(
                        backgroundColor: Colors.cyan,
                        body: SafeArea(
                        child: Center(
                            child: Column(
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    crossAxisAlignment: CrossAxisAlignment.center,
                                    children: <Widget>[
                                        Center(
                                                child: Row(
                                                        mainAxisAlignment: MainAxisAlignment.center,
                                                        crossAxisAlignment: CrossAxisAlignment.center,
                                                        children: const [
                                                            FaIcon(FontAwesomeIcons.envelope, color: Colors.white, size: 40),
                                                            SizedBox(width: 15),
                                                            Text('Envelope', style: TextStyle(fontSize: 40, color: Colors.white),)
                                                        ]
                                                ),
                                        ),
                                        const SizedBox(height: 10),
                                        Padding(
                                                padding: const EdgeInsets.all(15),
                                                child: Column (
                                                        children: [
                                                            ElevatedButton(
                                                                    child: const Text('Login'),
                                                                    onPressed: () => {
                                                                        Navigator.of(context).push(
                                                                                MaterialPageRoute(builder: (context) => const Login()),
                                                                        ),
                                                                    },

                                                                    style: buttonStyle,
                                                            ),
                                                            const SizedBox(height: 20),
                                                            ElevatedButton(
                                                                    child: const Text('Sign Up'),
                                                                    onPressed: () => {
                                                                        Navigator.of(context).push(
                                                                                MaterialPageRoute(builder: (context) => const Signup()),
                                                                        ),
                                                                    },
                                                                    style: buttonStyle,
                                                            ),
                                                        ]
                                                ),
                                        ),
                                    ],
                            ),
                    ),
                ),
            ),
        );
    }
}
